Create BP Record
POST /ws/rest/service/v1/bp/record/{project_number}
Purpose
Create a record in a specific BP in a shell based on shell number or from company level if project/shell number is not provided.
To avoid errors and maintain data integrity when using multiple DEs with the same field label, ensure that the applicable DEs have the same direction—Input, Output, or Both—or that the combinations of Both/Output or Input/Output are not used.
The input JSON shall provide various options to be considered for fetching the data.
Request Format
All parameters should be URL encoded. POST body is a JSON
Note: POST call has input & output both as JSON in the body.
If "record_no" is not provided, an auto-generated record_no is assigned to the record. If a unique "record_no" is provided, the record is created with the specified record_no.
- "bpname" is mandatory and is part of options form parameter.
- If "workflow_details" is not specified, the fall back will be the auto-creation settings defined on the BP Setup.
- If "workflow_details" is specified, all three parameters, user_name, workflow_name, and action_name are mandatory.
- Summary CBS codes cannot be included in Cost allocation line items when creating or updating commits of SPA BP records through REST services.
- When a data element (DE) is set to auto-populate from a Base Commit, Change Commit, or an SOV, the auto-populated values takes precedence when 0 value is sent for those DEs in CSV, Excel, or Rest API. Any value specified in the input request is ignored and the auto-populated values from Base Commit, Change Commit, or SOV will be used.
Behavior of the Due Date (due_date) Field
When you create workflow BP records through a REST service, the system currently sets the Due Date automatically based on the Workflow Settings; the Due Date provided in the input request is ignored.
When you update workflow BP records through a REST service, you cannot change the Due Date.
The following validations are performed:
- If the user is a valid active user in the project.
Note: The system validates whether the selected user's company exists. If not, the system adds the Partner Company as a Member Company.
- Workflow name is valid and active.
- User is an assignee (user/group) on the creation step of the workflow.
- Action name is valid outgoing link from the creation step.
- Error messages:
- Enter a valid or an active user. (Missing key or invalid user name)
- The workflow name is not valid. (Missing key or invalid/inactive workflow name)
- The user does not have an active workflow template. (User is not an assignee on the creation step)
- The workflow action name is not valid. (Missing key or invalid outgoing action name from creation step)
Path Parameter
project_number: Specify the Project number in which the records exists; if not provided, records are from Company Level.
Response Format
A JSON object is returned in the following format.
{
"data": [],
"message": [],
"status": <REST status code value>
}
A successful response displays a status code 200.
A failed response displays a message with a status code.
Sample Request
{
"options": {
"bpname": "Vendors",
"workflow_details":
{
"workflow_name": "workflow_name",
"user_name" : "first_name last_name",
"action_name" : "action_name"
}
},
"data": [
{
"record_no":"hello",
"uuu_user_id": "a@abc.com",
"uuu_record_last_update_date": "04-12-2018",
"uveFaxTB16": null,
"uveCertificateNoTB64": null,
"uvePrimaryContactTB64": "a",
"title": "v-00101",
"uveLicenseNoTB16": null,
"uuu_contact_company": "v-00101",
"uveCOIAmoutCA": 0,
"_bp_lineitems": [
{
"uirCntctFstNmTB": "a",
"uuu_user_workphone": null,
"uuu_tab_id": "List of Contacts",
"title": "t",
"ugenAddress1TXT120": null,
"ugenAddress2TXT120": null,
"ugenCountryPD": null,
"ugenCityTXT50": null,
"short_desc": "Vendor Contact",
"uriCntctLstNmTB": "b",
"ugenStatePD": null,
"ugenZipCodeTXT16": null,
"uveEmailTB120": "hello@abc.com",
"ugenAddress3TXT120": null
}
],
"uvePolicyNoTB32": null,
"uveVendorTypePD": "Architect",
"ugenCityTXT50": null,
"uveCoiExpDOP": null,
"uuu_dm_publish_path": "v_path",
"uuu_contact_last_name": "b",
"ugenZipCodeTXT16": null,
"uveEmailTB120": "a@abc.com",
"ugenAddress3TXT120": null,
"uveReferenceIdTB16": null,
"uuu_creation_date": "04-12-2018",
"ugenRemarksTB4000": null,
"uvePhoneTB64": null,
"uveTaxIDTB16": null,
"uveMinorityBusCB": 0,
"uveInsuranceCoTB32": null,
"ugenExpirationDateDOP": null,
"uveWomanOwnedCB": 0,
"uveVendorNameTB50": "v-00101",
"ugenAddress1TXT120": null,
"uveDisadvantagedBusCB": 0,
"ugenDiscipline": null,
"creator_id": "Company Administrator",
"ugenAddress2TXT120": null,
"ugenCountryPD": null,
"uveVendorIDTB16": "v-00101",
"ugenStatePD": null,
"uuu_contact_first_name": "a",
"status": "Active"
}
]
}
Sample Success Response
{
"data": [],
"message": [
{
"_record_status": "success",
"uuu_user_id": "a@abc.com",
"uuu_record_last_update_date": "04-12-2018",
"uveFaxTB16": null,
"uveCertificateNoTB64": null,
"uvePrimaryContactTB64": "a",
"title": "v-00101",
"uveLicenseNoTB16": null,
"uuu_contact_company": "v-00101",
"uveCOIAmoutCA": 0,
"_bp_lineitems": [
{
"uirCntctFstNmTB": "a",
"uuu_user_workphone": null,
"uuu_tab_id": "List of Contacts",
"title": "t",
"ugenAddress1TXT120": null,
"ugenAddress2TXT120": null,
"ugenCountryPD": null,
"ugenCityTXT50": null,
"short_desc": "Vendor Contact",
"uriCntctLstNmTB": "b",
"ugenStatePD": null,
"ugenZipCodeTXT16": null,
"uveEmailTB120": "hello@abc.com",
"ugenAddress3TXT120": null
}
],
"uvePolicyNoTB32": null,
"record_no": "hello",
"_attachment": [
{
"file_name": "new 1.txt"
}
],
"uveVendorTypePD": "Architect",
"ugenCityTXT50": null,
"uveCoiExpDOP": null,
"uuu_dm_publish_path": "v_path",
"uuu_contact_last_name": "b",
"ugenZipCodeTXT16": null,
"uveEmailTB120": "a@abc.com",
"ugenAddress3TXT120": null,
"uveReferenceIdTB16": null,
"uuu_creation_date": "04-12-2018",
"ugenRemarksTB4000": null,
"uvePhoneTB64": null,
"uveTaxIDTB16": null,
"uveMinorityBusCB": 0,
"uveInsuranceCoTB32": null,
"ugenExpirationDateDOP": null,
"uveWomanOwnedCB": 0,
"uveVendorNameTB50": "v-00101",
"ugenAddress1TXT120": null,
"uveDisadvantagedBusCB": 0,
"ugenDiscipline": null,
"creator_id": "Company Administrator",
"ugenAddress2TXT120": null,
"ugenCountryPD": null,
"uveVendorIDTB16": "v-00101",
"ugenStatePD": null,
"uuu_contact_first_name": "a",
"status": "Active"
}
],
"status": 200
}
Sample Failed Response
{
"data": [],
"message": [
{
"_record_status": "Error Business Process record_no hello already exists. ",
"record": {
"uuu_user_id": "a@abc.com",
"uuu_record_last_update_date": "04-12-2018",
"uveFaxTB16": null,
"uveCertificateNoTB64": null,
"uvePrimaryContactTB64": "a",
"title": "v-00101",
"uveLicenseNoTB16": null,
"uuu_contact_company": "v-00101",
"uveCOIAmoutCA": 0,
"_bp_lineitems": [
{
"uirCntctFstNmTB": "a",
"uuu_user_workphone": null,
"uuu_tab_id": "List of Contacts",
"title": "t",
"ugenAddress1TXT120": null,
"ugenAddress2TXT120": null,
"ugenCountryPD": null,
"ugenCityTXT50": null,
"short_desc": "Vendor Contact",
"uriCntctLstNmTB": "b",
"ugenStatePD": null,
"ugenZipCodeTXT16": null,
"uveEmailTB120": "hello@abc.com",
"ugenAddress3TXT120": null
}
],
"uvePolicyNoTB32": null,
"record_no": "hello",
"_attachment": [
{
"file_name": "new 1.txt"
}
],
"uveVendorTypePD": "Architect",
"ugenCityTXT50": null,
"uveCoiExpDOP": null,
"uuu_dm_publish_path": "v_path",
"uuu_contact_last_name": "b",
"ugenZipCodeTXT16": null,
"uveEmailTB120": "a@abc.com",
"ugenAddress3TXT120": null,
"uveReferenceIdTB16": null,
"uuu_creation_date": "04-12-2018",
"ugenRemarksTB4000": null,
"uvePhoneTB64": null,
"uveTaxIDTB16": null,
"uveMinorityBusCB": 0,
"uveInsuranceCoTB32": null,
"ugenExpirationDateDOP": null,
"uveWomanOwnedCB": 0,
"uveVendorNameTB50": "v-00101",
"ugenAddress1TXT120": null,
"uveDisadvantagedBusCB": 0,
"ugenDiscipline": null,
"creator_id": "Company Administrator",
"ugenAddress2TXT120": null,
"ugenCountryPD": null,
"uveVendorIDTB16": "v-00101",
"ugenStatePD": null,
"uuu_contact_first_name": "a",
"status": "Active"
}
}
],
"status": 3000
}
Related Topics
Get BP Record With Attachments
Create BP Record with Attachment
Update BP Record with Attachment
Fetch BP Record List with filter_criteria
Payment Application with Auto-populate from SOV and Commits
Asynchronous Bulk BP Operations
Fetch List of Attached Files in a BP
Download a Single Attached File in a BP
Download Multipart or Large Files
Last Published Thursday, February 19, 2026